#define SIGEL_USE_ONLY


//#define SIGEL_DEVIL
//#define SIGEL_SOUND
//#define SIGEL_SCRIPT
//#define SIGEL_PHYSX
//#define SIGEL_NETWORK

#include <sigel/ISigel.h>

Billboard *expbb = 0;
Texture *texexp = 0;

float csize = 25.0f;

float tm;

class Explode
{
	Entity* ent;
	float frame;
public:
	Explode();
	~Explode();

	void Update();
};

typedef std::list<Explode*> Texplist;
Texplist explist;

Explode::Explode()
{
	ent = new Entity(expbb);
	ent->BindTex(texexp);
	ent->Blend(BM_ADD);

	ent->Position(rnd(-csize,csize),rnd(-csize,csize),rnd(-csize,csize));
	frame = rnd(0,39);
	explist.push_back(this);
}

Explode::~Explode()
{
	delete ent;
	explist.remove(this);
}

void Explode::Update()
{
	frame+=tm;

	if(frame>39)
	{
		frame = rnd(0,3);
		ent->Position(rnd(-csize,csize),rnd(-csize,csize),rnd(-csize,csize));
	}
	else
	{
		ent->SetFrame(frame);
	}
}

sGAME
{
	debug::startlog();
	Init(1024,768,32,2,0);
	AppTitle("ExplodesBenchmark");

	VWait(0);
	CameraHelper ch;

	TFont *fnt = new TFont("tahoma.txt");

	expbb = new Billboard(1);
	texexp = new Texture("boomstrip2.bmp");

	expbb->AnimLenght(40);

	for(int i=0;i<4000;++i)
	{
			Explode *temp = new Explode();
	}

	int cnt = 0;

	
	while(!KeyDown(VK_ESCAPE))
	{
		//3d
		tm = GetFrameTime()/1000.0f * 40.0f;

		misc::update_this<Texplist>(explist);

		ch.Update();
		Render();
		//2d

		if(KeyDown(VK_SPACE))
			Sleep(18);

		fnt->Text(GetFPS(),10,10);
		fnt->Text(RenderedTris(),10,25);
		Flip();
	}

	DeInit();
	debug::endlog();
};